## curry-tools 3.3.0

=== Makefile ===
# Generate various tools for Curry

# Required:
# - root location of the Curry System specified by variable ROOT

ROOT ?= $(error Please specify the variable ROOT)

export BINDIR     = $(ROOT)/bin
export LIBDIR     = $(ROOT)/lib
export CLEANCURRY = $(BINDIR)/cleancurry
export REPL       = $(BINDIR)/curry

# Directory names of all tools:
ALLTOOLDIRS = $(filter-out $(EXCLUDES), $(sort $(notdir $(shell find . -mindepth 1 -maxdepth 1 -type d))))
EXCLUDES = .git
# Directory names of all tools having a Makefile:
TOOLDIRS = $(foreach d, $(ALLTOOLDIRS), $(shell test -f $(d)/Makefile && echo $(d)))

make_TOOLDIRS=$(addprefix make_,$(TOOLDIRS))
compile_TOOLDIRS=$(addprefix compile_,$(TOOLDIRS))
install_TOOLDIRS=$(addprefix install_,$(TOOLDIRS))
clean_TOOLDIRS=$(addprefix clean_,$(TOOLDIRS))
uninstall_TOOLDIRS=$(addprefix uninstall_,$(TOOLDIRS))

.PHONY: all
all: $(make_TOOLDIRS)

###########################################################################
# Make the different tools:

make_%:
	@cd $* && $(MAKE)

###########################################################################

.PHONY: compile
compile: $(compile_TOOLDIRS)

$(compile_TOOLDIRS):
	@cd $(patsubst compile_%,%,$@) && $(MAKE) compile

.PHONY: install
install: $(install_TOOLDIRS)

$(install_TOOLDIRS):
	@cd $(patsubst install_%,%,$@) && $(MAKE) install

.PHONY: clean
clean: $(clean_TOOLDIRS)

$(clean_TOOLDIRS):
	@cd $(patsubst clean_%,%,$@) && $(MAKE) clean

.PHONY: uninstall
uninstall: $(uninstall_TOOLDIRS)

$(uninstall_TOOLDIRS):
	@cd $(patsubst uninstall_%,%,$@) && $(MAKE) uninstall

########################################################################
# Testing the tools

# Tools with test suites:
TESTTOOLS = optimize cpm

# run the test suites to check the tools
.PHONY: runtest
runtest: $(addprefix runtest_,$(TESTTOOLS))

runtest_%:
	cd $* && $(MAKE) runtest

=== cpm/Makefile ===
# Makefile for Curry Package Manager (CPM)


# The tool name of the application:
TOOL      = $(BINDIR)/cypm
CURRYTOOL = $(BINDIR)/$(CURRYSYSTEM)-$(notdir $(TOOL))

# The default options for the REPL (options "rts -T" required for KiCS2
# in order to get elapsed times):
ifeq ($(CURRYSYSTEM),kics2)
export REPL_OPTS = --noreadline :set -time :set rts -T
else
export REPL_OPTS = --noreadline :set -time
endif

# Source modules of CPM:
DEPS = src/CPM/*.curry src/CPM/*/*.curry

.PHONY: all compile install clean uninstall runtest

all: install

install: compile
	rm -f $(TOOL) $(CURRYTOOL)
	cd $(BINDIR) && ln -s ../currytools/cpm/src/CPM.Main $(notdir $(TOOL))
	# install also cypm binary with Curry system as prefix:
	cd $(BINDIR) && ln -s $(notdir $(TOOL)) $(CURRYTOOL)

compile: src/CPM.Main

clean:
	rm -Rf src/CPM.Main src/.curry vendor/*/src/.curry

uninstall: clean
	rm -f $(TOOL) $(CURRYTOOL)

src/CPM.Main: src/CPM/ConfigPackage.curry $(DEPS)
	@echo Root location of Curry system: $(ROOT)
	@if [ ! -d "$(ROOT)" ] ; then echo "Error: not a valid directory!" ; exit 1; fi
	@export CURRYPATH="";						\
	for i in `ls vendor`; do 					\
		export CURRYPATH="$$CURRYPATH:`pwd`/vendor/$$i/src"; 	\
	done; 								\
	echo "Set CURRYPATH to $$CURRYPATH"; 				\
	cd src; $(REPL) --nocypm $(REPL_OPTS) :l CPM.Main :save :quit

src/CPM/ConfigPackage.curry: Makefile
	@echo "module CPM.ConfigPackage where" > $@
	@echo "packagePath :: String" >> $@
	@echo "packagePath = \"$(CURDIR)\"" >> $@
	@echo "packageVersion :: String" >> $@
	@echo "packageVersion = \"3.0.0\"" >> $@
	@echo "Curry configuration module '$@' written."

runtest:
	@export CURRYPATH="";						\
	for i in `ls vendor`; do					\
		export CURRYPATH="$$CURRYPATH:`pwd`/vendor/$$i/src";	\
	done;								\
	cd src && curry-check CPM.Package CPM.Resolution CPM.LookupSet

.PHONY: doc
doc:
	@export CURRYPATH="";						\
	for i in `ls vendor`; do					\
		export CURRYPATH="$$CURRYPATH:`pwd`/vendor/$$i/src";	\
	done;								\
	export CURRYPATH="$$CURRYPATH:`pwd`/src"; \
	curry-doc cdoc CPM.Main

.PHONY: manual
manual:
	pdflatex -output-directory=docs docs/manual.tex

=== optimize/Makefile ===
# Makefile for binding optimizer:

# replacement stuff
empty     :=
space     := $(empty) $(empty)

# The load path of the application:
LOADPATH = src:$(subst $(space),:,$(wildcard .cpm/packages/*/src))

# Source modules:
DEPS = .cpm/packages/*/src/*/*curry src/BindingOpt.curry

.PHONY: all
all: install

.PHONY: install
install: compile

.PHONY: compile
compile: BindingOpt

# Load the application into the interactive Curry system:
.PHONY: load
load: 
	$(REPL) -Dbindingoptimization=no --nocypm $(REPL_OPTS) :set path $(LOADPATH) :l BindingOpt

# Compile and create an executable of the binding optimizer:
BindingOpt: $(DEPS)
	$(REPL) -Dbindingoptimization=no --nocypm $(REPL_OPTS) :set path $(LOADPATH) :l BindingOpt :save :q

# Clean intermediate files:
.PHONY: clean
clean: 
	$(CLEANCURRY) -r

.PHONY: uninstall
uninstall: clean
	rm -f BindingOpt

# run the test suite
runtest:
	$(BINDIR)/cypm -d curry_bin=$(REPL) test

=== debian/changelog ===
curry-tools (3.3.0-2) unstable; urgency=medium

  * Re-upload to unstable.

 -- Mike Gabriel <sunweaver@debian.org>  Thu, 04 Feb 2021 22:42:27 +0100

curry-tools (3.3.0-1) experimental; urgency=medium

  * Upload to experimental.

  * New upstream version.
  * debian/control:
    + Bump Standards-Version: to 4.5.1. No changes needed.
  * debian/watch:
    + Update format version to 4.

 -- Mike Gabriel <sunweaver@debian.org>  Thu, 04 Feb 2021 16:32:48 +0100

=== debian/control ===
Source: curry-tools
Section: devel
Priority: optional
Build-Depends:
 cdbs,
 debhelper (>= 10~),
 tar (>= 1.28),
Maintainer: Debian Curry Maintainers <pkg-curry-maintainers@lists.alioth.debian.org>
Uploaders:
 Mike Gabriel <sunweaver@debian.org>,
 Michael Hanus <mh@informatik.uni-kiel.de>,
Rules-Requires-Root: no
Homepage: https://git.ps.informatik.uni-kiel.de/curry/curry-tools
Vcs-Browser: https://salsa.debian.org/pkg-curry-team/curry-tools
Vcs-Git: https://salsa.debian.org/pkg-curry-team/curry-tools.git
Standards-Version: 4.5.1

Package: curry-tools-source
Architecture: all
Depends:
 ${misc:Depends},
Breaks: pakcs (<< 2.2.0~),
Description: Tools that are used by different Curry systems, like PAKCS or KiCS2
 PAKCS and KICS2 are two different implementations of the programming
 language Curry. Curry is a functional programming language being developed
 at Kiel, Aachen and Portland University.
 .
 Whereas PAKCS is a Curry to Prolog compiler, KICS2 compiles Curry code
 into Haskell. Both compilers require two source code trees at compiler
 build time: curry-tools-source and curry-tools-source.
 .
 This package provides the source files of the curry-tools.

=== debian/watch ===
version=4
opts=dversionmangle=s/\+dfsg[0-9]*//,filenamemangle=s/.*\/curry-tools-v(\d\S+)\.tar\.gz/curry-tools-$1\.tar\.gz/g \
  https://git.ps.informatik.uni-kiel.de/curry/curry-tools/tags?sort=updated_desc .*/archive/v?(\d\S+)\/.*.tar\.gz
